<?php

namespace FiloBlu\ExtAnowaveGtmEnhancedEcommerceUaTrackingEc\Block;

class Track extends \Anowave\Ec\Block\Track {

    /**
     * Google Tag Manager Data
     *
     * @var \Anowave\Ec\Helper\Data
     */
    protected $_helper = null;

    /**
     * @var \Magento\Framework\DataObject
     */
    protected $adwords = null;

    /**
     * @var \Magento\Sales\Model\ResourceModel\Order\CollectionFactory
     */
    protected $_salesOrderCollection;

    public function __construct
    (
    \Magento\Framework\View\Element\Template\Context $context, \Magento\Sales\Model\ResourceModel\Order\CollectionFactory $salesOrderCollection, \Anowave\Ec\Helper\Data $helper, array $data = []
    ) {

        /**
         * Set Helper
         * @var \Anowave\Ec\Helper\Data 
         */
        $this->_helper = $helper;

        /**
         * Set order collection
         * 
         * @var \Magento\Sales\Model\ResourceModel\Order\CollectionFactory
         */
        $this->_salesOrderCollection = $salesOrderCollection;

        parent::__construct($context, $salesOrderCollection, $helper, $data);
    }

    public function getPageType() {
        if ($this->getRequest()->getFullActionName() == 'cms_index_index') {
            return 'home';
        }
        if ($this->getRequest()->getFullActionName() == 'catalog_product_view') {
            return 'product';
        }
        if ($this->getRequest()->getFullActionName() == 'catalog_category_view') {
            return 'category';
        }
        switch ($this->getRequest()->getControllerName()) {
            case 'cart': return 'cart';
            case 'result': return 'searchresults';
            default: return 'other';
        }
    }

    public function getPurchasePush() {
        if ($this->_helper->getConfig('ec/datalayer/purchase')) {
            return parent::getPurchasePush();
        }
        return json_encode(array(), JSON_PRETTY_PRINT);
    }

    public function getVisitorPush() {
        if ($this->_helper->getConfig('ec/datalayer/visitor')) {
            return parent::getVisitorPush();
        }
        return json_encode(array(), JSON_PRETTY_PRINT);
    }

    public function getDetailPushForward() {
        if ($this->_helper->getConfig('ec/datalayer/detail')) {
            return parent::getDetailPushForward();
        }
        return false;
    }

    public function getImpressionPushForward() {
        if ($this->_helper->getConfig('ec/datalayer/impression')) {
            return parent::getImpressionPushForward();
        }
        return false;
    }

    public function getSearchPush() {
        if ($this->_helper->getConfig('ec/datalayer/search')) {
            return parent::getSearchPush();
        }
        return false;
    }

    public function getAdWords() {
        if ($this->_helper->getConfig('ec/datalayer/adwords')) {
            return parent::getAdWords();
        }
        return new \Magento\Framework\DataObject(array('google_conversion_id' => null));
    }

}
